<?php

class NewsletterController extends RController {

    /**
     * @return array action filters
     */
    public function filters() {
        return array(
            'rights',
            'postOnly + delete', // we only allow deletion via POST request
        );
    }

    public function actions() {
        return array(
            'export' => array(
                'class' => 'admin.components.actions.ExportAction',
                'modelClass' => 'Newsletter',
            )
        );
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id) {
        $this->render('view', array(
            'model' => $this->loadModel($id),
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate() {
        $model = new Newsletter;
        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);
        if (isset($_POST['Newsletter'])) {
            $model->attributes = $_POST['Newsletter'];
            if ($model->save())
                $this->redirect(array('admin'));
        }
        $this->render('create', array(
            'model' => $model,
        ));
    }

    public function actionSend($id) {
        $model = $this->loadModel($id);
        $subscribers = NewsletterSubscriber::model()->findAll();
        if ($_POST && isset($_POST['recipients'])) {
            $recipients = $_POST['recipients'];
            Yii::import('application.extensions.phpmailer.JPhpMailer');
            $mail = new JPhpMailer;
            $mail->IsSMTP(); // enable SMTP
            $mail->SMTPDebug = 1; // debugging: 1 = errors and messages, 2 = messages only
            $mail->SMTPAuth = true; // authentication enabled
            $mail->SMTPSecure = Yii::app()->options->get('SMTP-SECURE'); // secure transfer enabled REQUIRED for GMail
            $mail->Host = Yii::app()->options->get('SMTP-HOST');
            $mail->Port = Yii::app()->options->get('SMTP-PORT'); // or 587
            $mail->IsHTML(true);
            $mail->Username = Yii::app()->options->get('SMTP-USERNAME');
            $mail->Password = Yii::app()->options->get('SMTP-PASSWORD');
            $mail->SetFrom(Yii::app()->options->get('SMTP-FROM-EMAIL'), Yii::app()->options->get('SMTP-FROM-NAME'));
            $mail->Subject = $model->title;
            $mail->Body = strip_tags($model->content);
            $mail->MsgHTML($model->content);
            $mail->CharSet = 'utf-8';
            foreach ($recipients as $recipient) {
                $mail->AddBCC($recipient, '');
            }
            $result = $mail->Send();
            $model->status = 1;
            $model->send_datetime = time();
            if ($model->save()) {
                $this->redirect(array('admin'));
            }
        }
        $this->render('send', array('model' => $model, 'subscribers' => $subscribers));
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id) {
        $model = $this->loadModel($id);
        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);
        if (isset($_POST['Newsletter'])) {
            $model->attributes = $_POST['Newsletter'];
            if ($model->save())
                $this->redirect(array('admin'));
        }
        $this->render('update', array(
            'model' => $model,
        ));
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id) {
        $this->loadModel($id)->delete();
        // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
        if (!isset($_GET['ajax'])) {
            Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully deleted.'));
            $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        }
    }

    /**
     * Lists all models.
     */
    public function actionIndex() {
        $dataProvider = new CActiveDataProvider('Newsletter');
        $this->render('index', array(
            'dataProvider' => $dataProvider,
        ));
    }

    /**
     * Manages all models.
     */
    public function actionAdmin() {
        $model = new Newsletter('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Newsletter']))
            $model->attributes = $_GET['Newsletter'];
        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer $id the ID of the model to be loaded
     * @return Newsletter the loaded model
     * @throws CHttpException
     */
    public function loadModel($id) {
        $model = Newsletter::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param Newsletter $model the model to be validated
     */
    protected function performAjaxValidation($model) {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'newsletter-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

}
